
% Resolucin numrica de las ecuaciones de Lorentz
% por el Mtodo de Runge-Kutta de 4 orden

clear all; 

dt=0.05; a=3;  b=1; r=26.5;   % Valores de los parmetros
dimt=500;  % Numero total de iteraciones
x1(1)=-0.1; x2(1)=0.1; x3(1)=0.2;  % Condicin inicial
% Clculo de las iteraciones sucesivas
%x1[n]=x1[n-1]+1/6*(k11+2*k12+2*k13+k14)
%x2[n]=x2[n-2]+1/6*(k21+2*k22+2*k23+k24)

for i=2:dimt
  k11=dt*(-a*x1(i-1)+a*x2(i-1));   
  k12=dt*(r*x1(i-1)+x2(i-1)-x1(i-1)*x3(i-1)); 
  k13=dt*(x1(i-1)*x2(i-1)-b*x3(i-1));
  
  k21=dt*(-a*(x1(i-1)+k11/2)+a*(x2(i-1)+k12/2));   
  k22=dt*(r*(x1(i-1)+k11/2)+x2(i-1)+k12/2-(x1(i-1)+k11/2)*(x3(i-1)+k13/2)); 
  k23=dt*((x1(i-1)+k11/2)*(x2(i-1)+k12/2)-b*(x3(i-1)+k13/2));
  
  k31=dt*(-a*(x1(i-1)+k21/2)+a*(x2(i-1)+k22/2));   
  k32=dt*(r*(x1(i-1)+k21/2)+x2(i-1)+k22/2-(x1(i-1)+k21/2)*(x3(i-1)+k23/2)); 
  k33=dt*((x1(i-1)+k21/2)*(x2(i-1)+k22/2)-b*(x3(i-1)+k23/2));
  
  k41=dt*(-a*(x1(i-1)+k31)+a*(x2(i-1)+k32));   
  k42=dt*(r*(x1(i-1)+k31)+x2(i-1)+k32-(x1(i-1)+k31)*(x3(i-1)+k33)); 
  k43=dt*((x1(i-1)+k31)*(x2(i-1)+k32)-b*(x3(i-1)+k33));
  
  x1(i)=x1(i-1)+k11/6+k21/3+k31/3+k41/6;
  x2(i)=x2(i-1)+k12/6+k22/3+k32/3+k42/6;
  x3(i)=x3(i-1)+k13/6+k23/3+k33/3+k43/6;
end

figure(3);
plot3(x1,x2,x3,'r');grid on;title('Ecuaciones de Lorentz resueltas con el metodo R-K 4 orden PASO=0.05')
hold off;
% Dibuja la dependencia temporal de x e y
t=[1:dimt]*dt;
figure(4);
plot(t,x1,'-b','LineWidth',2.000);hold on;
plot(t,x2,'-r','LineWidth',2.000);grid on;
plot(t,x3,'-g','LineWidth',2.000);grid on;
hold off;