% Resolucin numrica ejercicio 1 del practico 0 por el Mtodo de Euler

clc; clear all; close all;

inc=0.01;
paso=[0.05:inc:2.5]; tau=1;   % Valores de los parmetros
indice=1;
dimt=100;   % Numero total de iteraciones
xe(1)=0;   % Condicin inicial Euler
xr(1)=0;   % Condicion inicial Runge-Kutta 4

% Clculo de las iteraciones sucesivas Metodo de Euler
for i=2:dimt
  xe(i)=xe(i-1)+paso(indice)*(1/tau)*(1-xe(i-1));
end

% Metodo R-K de cuarto orden
for i=2:dimt
  k1=paso(indice)*(1/tau)*(1-xr(i-1));       
  k2=paso(indice)*(1/tau)*(1-xr(i-1)-k1/2);
  k3=paso(indice)*(1/tau)*(1-xr(i-1)-k2/2);
  k4=paso(indice)*(1/tau)*(1-xr(i-1)-k3);
  xr(i)=xr(i-1)+k1/6+k2/3+k3/3+k4/6;
end

%y=zeros([1,1000]);
%tt=[0:0.01:10];
%y=1-exp(-tt);

% Dibuja la dependencia temporal de x 
t=[1:dimt]*paso(1);
y=1-exp(-t);
xmin=0; xmax=4.5; ymin=0; ymax=1.1;

subplot(3,1,1); plot(t,xe,'-b','LineWidth',2.000); title('Metodo Euler'); 
axis([xmin,xmax,ymin,ymax]);grid on;
hold on;
subplot(3,1,2); plot(t,xr,'-g','LineWidth',2.000); title('Metodo Runge-Kutta 4'); 
axis([xmin,xmax,ymin,ymax]);grid on;
subplot(3,1,3); plot(t,y,'-r','LineWidth',2.000); title('Resolucion Analitica'); 
axis([xmin,xmax,ymin,ymax]);grid on;
hold off;

figure(2);

plot(t,xe,'-b','LineWidth',2.000); title('Contraste entre soluciones'); 
axis([xmin,xmax,ymin,ymax]);grid on;
hold on;
plot(t,xr,'-g','LineWidth',2.000); 
plot(t,y,'-r','LineWidth',2.000); 
legend('Metodo Euler','Metodo Runge-Kutta','Solucion Analitica');
hold off;

figure(3);

plot(t,xe,'-b','LineWidth',2.000); title('Comparacion entre los dos metodos'); 
axis([xmin,xmax,ymin,ymax]);grid on;
hold on;
plot(t,xr,'-g','LineWidth',2.000); 
legend('Metodo Euler','Metodo Runge-Kutta');
hold off;


xmin=0; xmax=6; ymin=0; ymax=100;
figure(4);
error_e=(abs(y-xe)./y)*100;
error_r=(abs(y-xr)./y)*100;


plot(t,error_e,'-b','LineWidth',2.000); title('Comparacion Error entre los dos metodos contra la solucion analitica'); 
axis([xmin,xmax,ymin,ymax]);grid on;
hold on;
plot(t,error_r,'-g','LineWidth',2.000);
legend('Error % Euler','Error % Runge-Kutta');
hold off;
