% Resolucin numrico del oscilador armnico amortiguado
% por el Mtodo de Runge-Kutta de 4 orden

clear all; close all;

deltat=0.1; b=1;  omega=1;   % Valores de los parmetros
dimt=100;  % Numero total de iteraciones
x1(1)=10; x2(1)=-1;   % Condicin inicial
% Clculo de las iteraciones sucesivas
%x1[n]=x1[n-1]+1/6*(k11+2*k12+2*k13+k14)
%x2[n]=x2[n-2]+1/6*(k21+2*k22+2*k23+k24)

for i=2:dimt
  k11=deltat*x2(i-1);   
  k12=deltat*(-omega^2*x1(i-1)-b*x2(i-1)); 
  
  k21=deltat*(x2(i-1)+k12/2);
  k22=deltat*(-omega^2*(x1(i-1)+k11/2)-b*(x2(i-1)+k12/2));  
  
  k31=deltat*(x2(i-1)+k22/2);
  k32=deltat*(-omega^2*(x1(i-1)+k21/2)-b*(x2(i-1)+k22/2));  
  
  k41=deltat*(x2(i-1)+k32);
  k42=deltat*(-omega^2*(x1(i-1)+k31)-b*(x2(i-1)+k32));   

  x1(i)=x1(i-1)+k11/6+k21/3+k31/3+k41/6;
  x2(i)=x2(i-1)+k12/6+k22/3+k32/3+k42/6;
end

% Dibuja los resultados en el espacio de fases
figure(1);hold off;
plot(x1,x2,'-','LineWidth',2.000);grid on;

% Dibuja la dependencia temporal de x e y
t=[1:dimt]*deltat;
figure(2);hold off;
plot(t,x1,'-b','LineWidth',2.000);hold on;
plot(t,x2,'-r','LineWidth',2.000);grid on;
